package com.huimv.farm.piglet;

import com.huimv.exception.RestExceptionHandler;
import com.huimv.redis.RedisTemplateUtil;
import com.huimv.tools.MapParamConverter;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.data.redis.connection.RedisConnectionFactory;

@EnableDiscoveryClient
@EnableFeignClients
@SpringBootApplication
public class HuimvCloudFarmPigletApplication {

    public static void main(String[] args) {
        SpringApplication.run(HuimvCloudFarmPigletApplication.class, args);
    }

    @Bean
    public MapParamConverter mapParamConverter(){
        return new MapParamConverter();
    }

    @Bean
    public RestExceptionHandler restExceptionHandler(){
        return new RestExceptionHandler();
    }

    @Bean
    public RedisTemplateUtil redisTemplateUtil(RedisConnectionFactory factory){
        return new RedisTemplateUtil(factory);
    }
}
