package com.huimv.farm.piglet.controller;

import com.huimv.CommonConstant;
import com.huimv.exception.PlatformException;
import com.huimv.farm.piglet.domain.FarrowingHouse;
import com.huimv.farm.piglet.repo.FarrowingHouseRepository;
import com.huimv.response.OkResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/house")
public class HouseController {

    @Autowired
    FarrowingHouseRepository farrowingHouseRepository;

    @PostMapping("/list")
    public Page<FarrowingHouse> list(@RequestParam(value = "pageNum", defaultValue = CommonConstant.PAGE_NUM_STR) Integer pageNum,
                                     @RequestParam(value = "pageSize", defaultValue = CommonConstant.PAGE_SIZE_STR) Integer pageSize,
                                     String searchStr) {
        if (StringUtils.isEmpty(searchStr)){
            return farrowingHouseRepository.findAll(PageRequest.of(pageNum - 1, pageSize));
        }else {
            return farrowingHouseRepository.findByNameContaining(searchStr, PageRequest.of(pageNum - 1, pageSize));
        }
    }

    @PostMapping("/delete")
    public OkResponse delete(@RequestParam(value = "id") Integer id){
        try{
            farrowingHouseRepository.deleteById(id);
            return new OkResponse("删除成功");
        }catch (Exception e){
            throw new PlatformException("delete failed", "删除失败");
        }
    }
}

