package com.huimv.farm.piglet.controller;

import com.huimv.AbstractPlatformController;
import com.huimv.CommonConstant;
import com.huimv.farm.piglet.domain.count.ProductionWarning;
import com.huimv.farm.piglet.repo.ProductionWarningRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * ProductionWarningController
 *
 * @author some one
 */
@RestController
@RequestMapping(value = "/production-warning")
public class ProductionWarningController extends AbstractPlatformController {

    @Autowired
    private ProductionWarningRepository objectRepository;

    @RequestMapping("/list")
    public Page<ProductionWarning> list(HttpServletRequest request,
                                        @RequestParam(name = "pageNum", defaultValue = CommonConstant.PAGE_NUM_STR) int pageNum,
                                        @RequestParam(name = "pageSize", defaultValue = CommonConstant.PAGE_SIZE_STR) int pageSize,
                                        @RequestParam(name = "searchStr", required = false) String searchStr) {
        Pageable pageable = PageRequest.of(pageNum - 1, pageSize, Sort.Direction.DESC, "id");
        if (!StringUtils.isEmpty(searchStr)) {
            return objectRepository.findBySearchStr(searchStr, pageable);
        }
        return objectRepository.findAllByStatus(0, pageable);
    }
}
