package com.huimv.farm.piglet.controller;

import com.huimv.CommonConstant;
import com.huimv.exception.PlatformException;
import com.huimv.farm.domain.constant.PigStatusEnum;
import com.huimv.farm.piglet.domain.Sow;
import com.huimv.farm.piglet.repo.SowRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Optional;

import org.springframework.web.bind.annotation.RequestParam;

@RestController
@RequestMapping("/sow")
public class SowController {

    @Autowired
    private SowRepository sowRepository;

    @RequestMapping("/get")
    public Object get(
            @RequestParam(name = "sowId") Integer sowId) {
        Sow sow = this.sowRepository.findById(sowId).orElse(null);
        if (sow == null)
            throw new PlatformException("sow_id_not_exist", "母猪ID不存在");
        return sow;
    }

    @PostMapping("/one")
    public Sow one(String earTag) {
        Optional<Sow> sow = sowRepository.findByEarTagNoAndIsEnable(earTag, true);
        if (sow.isPresent()) {
            return sow.get();
        } else {
            throw new PlatformException("sow does not exist", "母猪不存在");
        }
    }

    @PostMapping("/list")
    public Page<Sow> list(@RequestParam(name = "pageNum", defaultValue = CommonConstant.PAGE_NUM_STR) int pageNum,
                    @RequestParam(name = "pageSize", defaultValue = CommonConstant.PAGE_SIZE_STR) int pageSize) {
        return sowRepository.findByStatusLessThan(PigStatusEnum.STATUS_ELIMINATION.getCode(), PageRequest.of(pageNum - 1, pageSize));
    }
}

