package com.huimv.farm.piglet.domain;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;

@AllArgsConstructor
@NoArgsConstructor
@Data
@Entity(name="device")
public class Device{

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Integer id;
    //设备编码,产床编号,设备名称，栋舍，安装时间，状态
    private Integer code;
    private String tableCode;
    private String name;
    @OneToOne
    @JoinColumn(name = "house_id", referencedColumnName="id")
    private FarrowingHouse house;
    private Date installTime;
    private Integer status;
    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", updatable = false)
    private Date created;
}
