package com.huimv.farm.piglet.domain;

import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;

@AllArgsConstructor
@NoArgsConstructor
@Entity(name="litter")
public class Litter {

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Integer id;
    //母羊ID，母羊耳标，绑定时间，预产期，分娩时间，日龄，生产数量，断奶时间，断奶存活数量
    @OneToOne
    @JoinColumn(name = "mother_id", referencedColumnName="id")
    private Sow mother;
    private Date bindTime;
    private Date dueDate;
    private Date deliverTime;
    @Transient
    private Integer dayOfAge;
    private Integer deliverNumber;
    private Date weaningTime;
    private Integer weaningNumber;
    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", updatable = false)
    private Date created;

    public Sow getMother() {
        return mother;
    }

    public void setMother(Sow mother) {
        this.mother = mother;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Date getBindTime() {
        return bindTime;
    }

    public void setBindTime(Date bindTime) {
        this.bindTime = bindTime;
    }

    public Date getDueDate() {
        return dueDate;
    }

    public void setDueDate(Date dueDate) {
        this.dueDate = dueDate;
    }

    public Date getDeliverTime() {
        return deliverTime;
    }

    public void setDeliverTime(Date deliverTime) {
        this.deliverTime = deliverTime;
    }

    public Integer getDayOfAge() {
        if (this.deliverTime != null){
            return ((Long)((new Date().getTime() - this.deliverTime.getTime()) / (24 * 60 * 60 * 1000))).intValue();
        }else {
            return null;
        }
    }

    public Integer getDeliverNumber() {
        return deliverNumber;
    }

    public void setDeliverNumber(Integer deliverNumber) {
        this.deliverNumber = deliverNumber;
    }

    public Date getWeaningTime() {
        return weaningTime;
    }

    public void setWeaningTime(Date weaningTime) {
        this.weaningTime = weaningTime;
    }

    public Integer getWeaningNumber() {
        return weaningNumber;
    }

    public void setWeaningNumber(Integer weaningNumber) {
        this.weaningNumber = weaningNumber;
    }

    public Date getCreated() {
        return created;
    }

    public void setCreated(Date created) {
        this.created = created;
    }
}