package com.huimv.farm.piglet.domain;

import com.huimv.converter.KeyValueStringConverter;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;
import java.util.Map;

@AllArgsConstructor
@NoArgsConstructor
@Data
@Entity(name="obstetric_table")
public class ObstetricTable {

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Integer id;
    //产床编码,产床状态,窝编号,产房ID，设备ID，设备通道，其他信息
    private String code;
    private Integer status;
    @OneToOne
    @JoinColumn(name = "litter_id", referencedColumnName="id")
    private Litter litter;
    @OneToOne
    @JoinColumn(name = "house_id", referencedColumnName="id")
    private FarrowingHouse house;
    private Integer deviceId;
    private Integer deviceCh;
    private String feeder;
    //数据字段
    @Column(columnDefinition = "TEXT")
    @Convert(converter = KeyValueStringConverter.class)
    private Map<String, Object> data;
    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", updatable = false)
    private Date created;
}
