package com.huimv.farm.piglet.domain;

import java.util.Date;
import java.util.Map;
import javax.persistence.*;
import com.huimv.converter.KeyValueStringConverter;
import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;

/**
 * @author yejijie
 * @created 2020年8月25日 上午8:50:42
 */
@AllArgsConstructor
@NoArgsConstructor
@Entity(name = "sow")
public class Sow {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    //耳标ID，耳标编码，批次，类别，状态，生日，日龄，别名，是否可用，其他信息
    private Integer earTagId;
    private String earTagNo;
    private String batch;
    private String category;
    private Integer status;
    private Date birthday;
    @Transient
    private Integer dayOfAge;
    /**
     * 用于显示什么猪等按需要来
     */
    private String mark;
    private Boolean isEnable;

    @Column(columnDefinition = "TEXT")
    @Convert(converter = KeyValueStringConverter.class)
    private  Map<String, Object> data;

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", updatable = false)
    private Date created;

    @Column(columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP")
    private Date updated;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getEarTagId() {
        return earTagId;
    }

    public void setEarTagId(Integer earTagId) {
        this.earTagId = earTagId;
    }

    public String getEarTagNo() {
        return earTagNo;
    }

    public void setEarTagNo(String earTagNo) {
        this.earTagNo = earTagNo;
    }

    public String getBatch() {
        return batch;
    }

    public void setBatch(String batch) {
        this.batch = batch;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        status = status;
    }

    public Date getBirthday() {
        return birthday;
    }

    public void setBirthday(Date birthday) {
        this.birthday = birthday;
    }

    public Integer getDayOfAge() {
        if (this.birthday != null) {
            return ((Long) ((new Date().getTime() - this.birthday.getTime()) / (24 * 60 * 60 * 1000))).intValue();
        } else {
            return null;
        }
    }

    public String getMark() {
        return mark;
    }

    public void setMark(String mark) {
        this.mark = mark;
    }

    public Boolean getEnable() {
        return isEnable;
    }

    public void setEnable(Boolean enable) {
        isEnable = enable;
    }

    public Map<String, Object> getData() {
        return data;
    }

    public void setData(Map<String, Object> data) {
        this.data = data;
    }

    public Date getCreated() {
        return created;
    }

    public void setCreated(Date created) {
        this.created = created;
    }

    public Date getUpdated() {
        return updated;
    }

    public void setUpdated(Date updated) {
        this.updated = updated;
    }
}
