package com.huimv.farm.piglet.feign.clients;


import com.huimv.farm.piglet.feign.clients.conf.FeignConfiguration;
import com.huimv.publics.domain.SystemConfigData;
import com.huimv.publics.domain.TreeNode;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;
import java.util.Optional;

/**
 * @author yejijie
 * @created 2020年7月15日 下午1:35:12
 */
@FeignClient(name = "publics", configuration = FeignConfiguration.class)
public interface PublicFeignClient {

    @PostMapping(value = "/treenode/getTreeByCode")
    Optional<TreeNode> getTreeByCode(@RequestParam(value = "code") String code, @RequestParam(value = "hasSub") Boolean hasSub);

    @PostMapping(value = "/treenode/feign/getTreeByCode")
    Optional<TreeNode> getTreeByOrgIdAndCode(@RequestParam(value = "orgId") Integer orgId, @RequestParam(value = "code") String code, @RequestParam(value = "hasSub") Boolean hasSub);

    @PostMapping(value = "/treenode/getNode")
    Optional<TreeNode> getTreeNode(@RequestParam(value = "id") Long id, @RequestParam(value = "hasSub") boolean hasSub);

    @PostMapping(value = "/treenode/listNodeByParent")
    Optional<TreeNode> listNodeByParent(@RequestParam(value = "parentId") String id, @RequestParam(value = "hasSub") boolean hasSub);

    @PostMapping(value = "/treenode/addNode")
    Optional<TreeNode> addNode(@RequestParam(name = "code", required = false) String code, @RequestParam(name = "nodeName") String nodeName,
                               @RequestParam(name = "parentId", defaultValue = "-1", required = false) Long parentId,
                               @RequestParam(name = "meta") Map<String, Object> meta, HttpServletRequest req);

    //不需要token获取配置
    @RequestMapping("/sysconf/feign/get")
    SystemConfigData get(@RequestParam(name = "orgId", required = false) Integer orgId,
                         @RequestParam(name = "id", required = false) Integer id,
                         @RequestParam(name = "code", required = false) String code);


}
