package com.huimv.farm.piglet.feign.clients.conf;

import feign.RequestInterceptor;
import feign.RequestTemplate;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.Enumeration;

/**
 * @author yejijie
 * @created 2020年7月15日 下午1:37:09
*/
@Configuration
public class FeignConfiguration implements RequestInterceptor {

	@Override
	public void apply(RequestTemplate template) {
		ServletRequestAttributes attrs = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
		if(attrs == null) return;//可能会没有哦
		HttpServletRequest req = attrs.getRequest();
		Enumeration<String> headerNames =  req.getHeaderNames();
		if(headerNames != null) {
			while(headerNames.hasMoreElements()) {
				String name = headerNames.nextElement();
                String values = req.getHeader(name);
                template.header(name, values);
			}
		}
	}

}
