package com.huimv.farm.piglet.repo;

import com.huimv.farm.piglet.domain.count.FenceOutPrediction;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface FenceOutPredictionRepository extends JpaRepository<FenceOutPrediction, Integer> {

    @Query(nativeQuery = true , value = "SELECT * FROM fence_out_prediction WHERE instr(id, ?1) > 0 OR instr(month, ?1) > 0 order by ?#{#pageable}")
    Page<FenceOutPrediction> findBySearchStr(String s, Pageable pageable);

    List<FenceOutPrediction> findByStatus(int status);

    List<FenceOutPrediction> findByStatusAndAreaId(int status, long areaId);
}
