package com.huimv.farm.piglet.repo;

import com.huimv.farm.piglet.domain.ObstetricTable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.List;
import java.util.Optional;

public interface ObstetricTableRepository extends JpaRepository<ObstetricTable, Integer> {

    Page<ObstetricTable> findByCodeContainingOrderByCode(String code, Pageable pageable);

    Page<ObstetricTable> findByHouseIdOrderByCode(Integer house, Pageable pageable);

    Page<ObstetricTable> findByHouseIdInOrderByCode(List<Integer> ids, Pageable pageable);

    Page<ObstetricTable> findByOrderByCode(Pageable pageable);

    Optional<ObstetricTable> findByCode(String code);

    Page<ObstetricTable> findByStatusOrderByCode(Integer status,Pageable pageable);

    Integer countByStatus(Integer status);
    
    Optional<ObstetricTable> findByDeviceIdAndDeviceCh(Integer deviceId,Integer deviceCh);
}
