package com.huimv.farm.piglet.repo;

import com.huimv.farm.piglet.domain.count.ProductionTraceability;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface ProductionTraceabilityRepository extends JpaRepository<ProductionTraceability, Integer> {

    @Query(nativeQuery = true , value = "SELECT * FROM production_traceability WHERE instr(id, ?1) > 0 OR instr(week, ?1) > 0 order by ?#{#pageable}")
    Page<ProductionTraceability> findBySearchStr(String s, Pageable pageable);

    ProductionTraceability findByWeek(String week);
}
