package com.huimv.farm.piglet.repo;

import com.huimv.farm.piglet.domain.count.ProductionWarning;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface ProductionWarningRepository extends JpaRepository<ProductionWarning, Integer> {

    @Query(nativeQuery = true , value = "SELECT * FROM production_warning WHERE instr(id, ?1) > 0 OR instr(message, ?1) > 0 AND status = 0 order by ?#{#pageable}")
    Page<ProductionWarning> findBySearchStr(String s, Pageable pageable);

    //查询状态数据：
    @Query(nativeQuery = true, value = "SELECT * FROM production_warning WHERE status = ?1 ORDER BY ?#{#pageable}")
    Page<ProductionWarning> findAllByStatus(int status, Pageable pageable);
}
