package com.huimv.farm.piglet.repo;

import com.huimv.farm.piglet.domain.count.PsyAnalysisRecord;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

public interface PsyAnalysisRecordRepository extends JpaRepository<PsyAnalysisRecord, Integer> {

    @Query(nativeQuery = true , value = "SELECT * FROM psy_analysis_record WHERE instr(id, ?1) > 0 OR instr(psy_value, ?1) > 0 order by ?#{#pageable}")
    Page<PsyAnalysisRecord> findBySearchStr(String s, Pageable pageable);

    PsyAnalysisRecord findByMonth(String month);
}
