package com.huimv.farm.piglet.repo;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;

import com.huimv.farm.piglet.domain.Sow;
import org.springframework.data.jpa.repository.Query;

public interface SowRepository extends JpaRepository<Sow, Integer> {

	Optional<Sow> findByEarTagIdAndIsEnable(Integer earTagId,Boolean isEnable);

	Optional<Sow> findByEarTagNoAndIsEnable(String earTagNo,Boolean isEnable);

	Page<Sow> findByStatusLessThan(Integer status, Pageable pageable);

	@Query(nativeQuery = true, value = "SELECT ear_tag_no FROM sow WHERE DATEDIFF(now(), birthday) > :overAge")
	List<String> overAge(Integer overAge);
}
